#pragma once
#include "zsp/ast/impl/VisitorBase.h"
#include <Python.h>
namespace zsp {
namespace ast {

class PyBaseVisitor : public VisitorBase {
public:
    PyBaseVisitor(PyObject *proxy);
    virtual ~PyBaseVisitor();
private:
    PyObject *m_proxy;
    public:
    void py_acceptExprAggrMapElem(IExprAggrMapElem *i);
    void py_acceptTemplateParamDeclList(ITemplateParamDeclList *i);
    void py_acceptExprAggrStructElem(IExprAggrStructElem *i);
    void py_acceptTemplateParamValue(ITemplateParamValue *i);
    void py_acceptTemplateParamValueList(ITemplateParamValueList *i);
    void py_acceptActivityJoinSpec(IActivityJoinSpec *i);
    void py_acceptRefExpr(IRefExpr *i);
    void py_acceptActivityMatchChoice(IActivityMatchChoice *i);
    void py_acceptScopeChild(IScopeChild *i);
    void py_acceptActivitySelectBranch(IActivitySelectBranch *i);
    void py_acceptSymbolRefPath(ISymbolRefPath *i);
    void py_acceptExecTargetTemplateParam(IExecTargetTemplateParam *i);
    void py_acceptExpr(IExpr *i);
    void py_acceptAssocData(IAssocData *i);
    void py_acceptSymbolImportSpec(ISymbolImportSpec *i);
    virtual void visitExprAggrMapElem(IExprAggrMapElem *i) override;
    void py_visitExprAggrMapElemBase(IExprAggrMapElem *i);
    virtual void visitTemplateParamDeclList(ITemplateParamDeclList *i) override;
    void py_visitTemplateParamDeclListBase(ITemplateParamDeclList *i);
    virtual void visitExprAggrStructElem(IExprAggrStructElem *i) override;
    void py_visitExprAggrStructElemBase(IExprAggrStructElem *i);
    virtual void visitTemplateParamValue(ITemplateParamValue *i) override;
    void py_visitTemplateParamValueBase(ITemplateParamValue *i);
    virtual void visitTemplateParamValueList(ITemplateParamValueList *i) override;
    void py_visitTemplateParamValueListBase(ITemplateParamValueList *i);
    virtual void visitActivityJoinSpec(IActivityJoinSpec *i) override;
    void py_visitActivityJoinSpecBase(IActivityJoinSpec *i);
    virtual void visitRefExpr(IRefExpr *i) override;
    void py_visitRefExprBase(IRefExpr *i);
    virtual void visitActivityMatchChoice(IActivityMatchChoice *i) override;
    void py_visitActivityMatchChoiceBase(IActivityMatchChoice *i);
    virtual void visitScopeChild(IScopeChild *i) override;
    void py_visitScopeChildBase(IScopeChild *i);
    virtual void visitActivitySelectBranch(IActivitySelectBranch *i) override;
    void py_visitActivitySelectBranchBase(IActivitySelectBranch *i);
    virtual void visitSymbolRefPath(ISymbolRefPath *i) override;
    void py_visitSymbolRefPathBase(ISymbolRefPath *i);
    virtual void visitExecTargetTemplateParam(IExecTargetTemplateParam *i) override;
    void py_visitExecTargetTemplateParamBase(IExecTargetTemplateParam *i);
    virtual void visitExpr(IExpr *i) override;
    void py_visitExprBase(IExpr *i);
    virtual void visitAssocData(IAssocData *i) override;
    void py_visitAssocDataBase(IAssocData *i);
    virtual void visitSymbolImportSpec(ISymbolImportSpec *i) override;
    void py_visitSymbolImportSpecBase(ISymbolImportSpec *i);
    virtual void visitPyImportFromStmt(IPyImportFromStmt *i) override;
    void py_visitPyImportFromStmtBase(IPyImportFromStmt *i);
    virtual void visitActivityJoinSpecBranch(IActivityJoinSpecBranch *i) override;
    void py_visitActivityJoinSpecBranchBase(IActivityJoinSpecBranch *i);
    virtual void visitActivityJoinSpecFirst(IActivityJoinSpecFirst *i) override;
    void py_visitActivityJoinSpecFirstBase(IActivityJoinSpecFirst *i);
    virtual void visitActivityJoinSpecNone(IActivityJoinSpecNone *i) override;
    void py_visitActivityJoinSpecNoneBase(IActivityJoinSpecNone *i);
    virtual void visitActivityJoinSpecSelect(IActivityJoinSpecSelect *i) override;
    void py_visitActivityJoinSpecSelectBase(IActivityJoinSpecSelect *i);
    virtual void visitPyImportStmt(IPyImportStmt *i) override;
    void py_visitPyImportStmtBase(IPyImportStmt *i);
    virtual void visitRefExprScopeIndex(IRefExprScopeIndex *i) override;
    void py_visitRefExprScopeIndexBase(IRefExprScopeIndex *i);
    virtual void visitRefExprTypeScopeContext(IRefExprTypeScopeContext *i) override;
    void py_visitRefExprTypeScopeContextBase(IRefExprTypeScopeContext *i);
    virtual void visitRefExprTypeScopeGlobal(IRefExprTypeScopeGlobal *i) override;
    void py_visitRefExprTypeScopeGlobalBase(IRefExprTypeScopeGlobal *i);
    virtual void visitScope(IScope *i) override;
    void py_visitScopeBase(IScope *i);
    virtual void visitScopeChildRef(IScopeChildRef *i) override;
    void py_visitScopeChildRefBase(IScopeChildRef *i);
    virtual void visitSymbolChild(ISymbolChild *i) override;
    void py_visitSymbolChildBase(ISymbolChild *i);
    virtual void visitActivitySchedulingConstraint(IActivitySchedulingConstraint *i) override;
    void py_visitActivitySchedulingConstraintBase(IActivitySchedulingConstraint *i);
    virtual void visitActivityStmt(IActivityStmt *i) override;
    void py_visitActivityStmtBase(IActivityStmt *i);
    virtual void visitSymbolScopeRef(ISymbolScopeRef *i) override;
    void py_visitSymbolScopeRefBase(ISymbolScopeRef *i);
    virtual void visitTemplateParamDecl(ITemplateParamDecl *i) override;
    void py_visitTemplateParamDeclBase(ITemplateParamDecl *i);
    virtual void visitConstraintStmt(IConstraintStmt *i) override;
    void py_visitConstraintStmtBase(IConstraintStmt *i);
    virtual void visitTemplateParamExprValue(ITemplateParamExprValue *i) override;
    void py_visitTemplateParamExprValueBase(ITemplateParamExprValue *i);
    virtual void visitTemplateParamTypeValue(ITemplateParamTypeValue *i) override;
    void py_visitTemplateParamTypeValueBase(ITemplateParamTypeValue *i);
    virtual void visitTypeIdentifier(ITypeIdentifier *i) override;
    void py_visitTypeIdentifierBase(ITypeIdentifier *i);
    virtual void visitTypeIdentifierElem(ITypeIdentifierElem *i) override;
    void py_visitTypeIdentifierElemBase(ITypeIdentifierElem *i);
    virtual void visitDataType(IDataType *i) override;
    void py_visitDataTypeBase(IDataType *i);
    virtual void visitExecStmt(IExecStmt *i) override;
    void py_visitExecStmtBase(IExecStmt *i);
    virtual void visitExecTargetTemplateBlock(IExecTargetTemplateBlock *i) override;
    void py_visitExecTargetTemplateBlockBase(IExecTargetTemplateBlock *i);
    virtual void visitExprAggrLiteral(IExprAggrLiteral *i) override;
    void py_visitExprAggrLiteralBase(IExprAggrLiteral *i);
    virtual void visitExprBin(IExprBin *i) override;
    void py_visitExprBinBase(IExprBin *i);
    virtual void visitExprBitSlice(IExprBitSlice *i) override;
    void py_visitExprBitSliceBase(IExprBitSlice *i);
    virtual void visitExprBool(IExprBool *i) override;
    void py_visitExprBoolBase(IExprBool *i);
    virtual void visitExprCast(IExprCast *i) override;
    void py_visitExprCastBase(IExprCast *i);
    virtual void visitExprCompileHas(IExprCompileHas *i) override;
    void py_visitExprCompileHasBase(IExprCompileHas *i);
    virtual void visitExprCond(IExprCond *i) override;
    void py_visitExprCondBase(IExprCond *i);
    virtual void visitExprDomainOpenRangeList(IExprDomainOpenRangeList *i) override;
    void py_visitExprDomainOpenRangeListBase(IExprDomainOpenRangeList *i);
    virtual void visitExprDomainOpenRangeValue(IExprDomainOpenRangeValue *i) override;
    void py_visitExprDomainOpenRangeValueBase(IExprDomainOpenRangeValue *i);
    virtual void visitExprHierarchicalId(IExprHierarchicalId *i) override;
    void py_visitExprHierarchicalIdBase(IExprHierarchicalId *i);
    virtual void visitExprId(IExprId *i) override;
    void py_visitExprIdBase(IExprId *i);
    virtual void visitExprIn(IExprIn *i) override;
    void py_visitExprInBase(IExprIn *i);
    virtual void visitExprListLiteral(IExprListLiteral *i) override;
    void py_visitExprListLiteralBase(IExprListLiteral *i);
    virtual void visitExprMemberPathElem(IExprMemberPathElem *i) override;
    void py_visitExprMemberPathElemBase(IExprMemberPathElem *i);
    virtual void visitExprNull(IExprNull *i) override;
    void py_visitExprNullBase(IExprNull *i);
    virtual void visitExprNumber(IExprNumber *i) override;
    void py_visitExprNumberBase(IExprNumber *i);
    virtual void visitExprOpenRangeList(IExprOpenRangeList *i) override;
    void py_visitExprOpenRangeListBase(IExprOpenRangeList *i);
    virtual void visitExprOpenRangeValue(IExprOpenRangeValue *i) override;
    void py_visitExprOpenRangeValueBase(IExprOpenRangeValue *i);
    virtual void visitExprRefPath(IExprRefPath *i) override;
    void py_visitExprRefPathBase(IExprRefPath *i);
    virtual void visitExprRefPathElem(IExprRefPathElem *i) override;
    void py_visitExprRefPathElemBase(IExprRefPathElem *i);
    virtual void visitExprStaticRefPath(IExprStaticRefPath *i) override;
    void py_visitExprStaticRefPathBase(IExprStaticRefPath *i);
    virtual void visitExprString(IExprString *i) override;
    void py_visitExprStringBase(IExprString *i);
    virtual void visitExprStructLiteral(IExprStructLiteral *i) override;
    void py_visitExprStructLiteralBase(IExprStructLiteral *i);
    virtual void visitExprStructLiteralItem(IExprStructLiteralItem *i) override;
    void py_visitExprStructLiteralItemBase(IExprStructLiteralItem *i);
    virtual void visitExprSubscript(IExprSubscript *i) override;
    void py_visitExprSubscriptBase(IExprSubscript *i);
    virtual void visitExprUnary(IExprUnary *i) override;
    void py_visitExprUnaryBase(IExprUnary *i);
    virtual void visitExtendEnum(IExtendEnum *i) override;
    void py_visitExtendEnumBase(IExtendEnum *i);
    virtual void visitFunctionDefinition(IFunctionDefinition *i) override;
    void py_visitFunctionDefinitionBase(IFunctionDefinition *i);
    virtual void visitFunctionImport(IFunctionImport *i) override;
    void py_visitFunctionImportBase(IFunctionImport *i);
    virtual void visitFunctionParamDecl(IFunctionParamDecl *i) override;
    void py_visitFunctionParamDeclBase(IFunctionParamDecl *i);
    virtual void visitMethodParameterList(IMethodParameterList *i) override;
    void py_visitMethodParameterListBase(IMethodParameterList *i);
    virtual void visitNamedScopeChild(INamedScopeChild *i) override;
    void py_visitNamedScopeChildBase(INamedScopeChild *i);
    virtual void visitPackageImportStmt(IPackageImportStmt *i) override;
    void py_visitPackageImportStmtBase(IPackageImportStmt *i);
    virtual void visitProceduralStmtIfClause(IProceduralStmtIfClause *i) override;
    void py_visitProceduralStmtIfClauseBase(IProceduralStmtIfClause *i);
    virtual void visitProceduralStmtMatch(IProceduralStmtMatch *i) override;
    void py_visitProceduralStmtMatchBase(IProceduralStmtMatch *i);
    virtual void visitProceduralStmtMatchChoice(IProceduralStmtMatchChoice *i) override;
    void py_visitProceduralStmtMatchChoiceBase(IProceduralStmtMatchChoice *i);
    virtual void visitActivityBindStmt(IActivityBindStmt *i) override;
    void py_visitActivityBindStmtBase(IActivityBindStmt *i);
    virtual void visitActivityConstraint(IActivityConstraint *i) override;
    void py_visitActivityConstraintBase(IActivityConstraint *i);
    virtual void visitProceduralStmtReturn(IProceduralStmtReturn *i) override;
    void py_visitProceduralStmtReturnBase(IProceduralStmtReturn *i);
    virtual void visitProceduralStmtYield(IProceduralStmtYield *i) override;
    void py_visitProceduralStmtYieldBase(IProceduralStmtYield *i);
    virtual void visitActivityLabeledStmt(IActivityLabeledStmt *i) override;
    void py_visitActivityLabeledStmtBase(IActivityLabeledStmt *i);
    virtual void visitSymbolChildrenScope(ISymbolChildrenScope *i) override;
    void py_visitSymbolChildrenScopeBase(ISymbolChildrenScope *i);
    virtual void visitTemplateCategoryTypeParamDecl(ITemplateCategoryTypeParamDecl *i) override;
    void py_visitTemplateCategoryTypeParamDeclBase(ITemplateCategoryTypeParamDecl *i);
    virtual void visitTemplateGenericTypeParamDecl(ITemplateGenericTypeParamDecl *i) override;
    void py_visitTemplateGenericTypeParamDeclBase(ITemplateGenericTypeParamDecl *i);
    virtual void visitConstraintScope(IConstraintScope *i) override;
    void py_visitConstraintScopeBase(IConstraintScope *i);
    virtual void visitConstraintStmtDefault(IConstraintStmtDefault *i) override;
    void py_visitConstraintStmtDefaultBase(IConstraintStmtDefault *i);
    virtual void visitConstraintStmtDefaultDisable(IConstraintStmtDefaultDisable *i) override;
    void py_visitConstraintStmtDefaultDisableBase(IConstraintStmtDefaultDisable *i);
    virtual void visitConstraintStmtExpr(IConstraintStmtExpr *i) override;
    void py_visitConstraintStmtExprBase(IConstraintStmtExpr *i);
    virtual void visitConstraintStmtField(IConstraintStmtField *i) override;
    void py_visitConstraintStmtFieldBase(IConstraintStmtField *i);
    virtual void visitTemplateValueParamDecl(ITemplateValueParamDecl *i) override;
    void py_visitTemplateValueParamDeclBase(ITemplateValueParamDecl *i);
    virtual void visitConstraintStmtIf(IConstraintStmtIf *i) override;
    void py_visitConstraintStmtIfBase(IConstraintStmtIf *i);
    virtual void visitConstraintStmtUnique(IConstraintStmtUnique *i) override;
    void py_visitConstraintStmtUniqueBase(IConstraintStmtUnique *i);
    virtual void visitDataTypeBool(IDataTypeBool *i) override;
    void py_visitDataTypeBoolBase(IDataTypeBool *i);
    virtual void visitDataTypeChandle(IDataTypeChandle *i) override;
    void py_visitDataTypeChandleBase(IDataTypeChandle *i);
    virtual void visitDataTypeEnum(IDataTypeEnum *i) override;
    void py_visitDataTypeEnumBase(IDataTypeEnum *i);
    virtual void visitDataTypeInt(IDataTypeInt *i) override;
    void py_visitDataTypeIntBase(IDataTypeInt *i);
    virtual void visitDataTypePyObj(IDataTypePyObj *i) override;
    void py_visitDataTypePyObjBase(IDataTypePyObj *i);
    virtual void visitDataTypeRef(IDataTypeRef *i) override;
    void py_visitDataTypeRefBase(IDataTypeRef *i);
    virtual void visitDataTypeString(IDataTypeString *i) override;
    void py_visitDataTypeStringBase(IDataTypeString *i);
    virtual void visitDataTypeUserDefined(IDataTypeUserDefined *i) override;
    void py_visitDataTypeUserDefinedBase(IDataTypeUserDefined *i);
    virtual void visitEnumDecl(IEnumDecl *i) override;
    void py_visitEnumDeclBase(IEnumDecl *i);
    virtual void visitEnumItem(IEnumItem *i) override;
    void py_visitEnumItemBase(IEnumItem *i);
    virtual void visitExprAggrEmpty(IExprAggrEmpty *i) override;
    void py_visitExprAggrEmptyBase(IExprAggrEmpty *i);
    virtual void visitExprAggrList(IExprAggrList *i) override;
    void py_visitExprAggrListBase(IExprAggrList *i);
    virtual void visitExprAggrMap(IExprAggrMap *i) override;
    void py_visitExprAggrMapBase(IExprAggrMap *i);
    virtual void visitExprAggrStruct(IExprAggrStruct *i) override;
    void py_visitExprAggrStructBase(IExprAggrStruct *i);
    virtual void visitExprRefPathContext(IExprRefPathContext *i) override;
    void py_visitExprRefPathContextBase(IExprRefPathContext *i);
    virtual void visitExprRefPathId(IExprRefPathId *i) override;
    void py_visitExprRefPathIdBase(IExprRefPathId *i);
    virtual void visitExprRefPathStatic(IExprRefPathStatic *i) override;
    void py_visitExprRefPathStaticBase(IExprRefPathStatic *i);
    virtual void visitExprRefPathStaticRooted(IExprRefPathStaticRooted *i) override;
    void py_visitExprRefPathStaticRootedBase(IExprRefPathStaticRooted *i);
    virtual void visitExprSignedNumber(IExprSignedNumber *i) override;
    void py_visitExprSignedNumberBase(IExprSignedNumber *i);
    virtual void visitExprUnsignedNumber(IExprUnsignedNumber *i) override;
    void py_visitExprUnsignedNumberBase(IExprUnsignedNumber *i);
    virtual void visitExtendType(IExtendType *i) override;
    void py_visitExtendTypeBase(IExtendType *i);
    virtual void visitField(IField *i) override;
    void py_visitFieldBase(IField *i);
    virtual void visitFieldClaim(IFieldClaim *i) override;
    void py_visitFieldClaimBase(IFieldClaim *i);
    virtual void visitFieldCompRef(IFieldCompRef *i) override;
    void py_visitFieldCompRefBase(IFieldCompRef *i);
    virtual void visitFieldRef(IFieldRef *i) override;
    void py_visitFieldRefBase(IFieldRef *i);
    virtual void visitFunctionImportProto(IFunctionImportProto *i) override;
    void py_visitFunctionImportProtoBase(IFunctionImportProto *i);
    virtual void visitFunctionImportType(IFunctionImportType *i) override;
    void py_visitFunctionImportTypeBase(IFunctionImportType *i);
    virtual void visitFunctionPrototype(IFunctionPrototype *i) override;
    void py_visitFunctionPrototypeBase(IFunctionPrototype *i);
    virtual void visitGlobalScope(IGlobalScope *i) override;
    void py_visitGlobalScopeBase(IGlobalScope *i);
    virtual void visitNamedScope(INamedScope *i) override;
    void py_visitNamedScopeBase(INamedScope *i);
    virtual void visitPackageScope(IPackageScope *i) override;
    void py_visitPackageScopeBase(IPackageScope *i);
    virtual void visitProceduralStmtAssignment(IProceduralStmtAssignment *i) override;
    void py_visitProceduralStmtAssignmentBase(IProceduralStmtAssignment *i);
    virtual void visitProceduralStmtBody(IProceduralStmtBody *i) override;
    void py_visitProceduralStmtBodyBase(IProceduralStmtBody *i);
    virtual void visitProceduralStmtBreak(IProceduralStmtBreak *i) override;
    void py_visitProceduralStmtBreakBase(IProceduralStmtBreak *i);
    virtual void visitProceduralStmtContinue(IProceduralStmtContinue *i) override;
    void py_visitProceduralStmtContinueBase(IProceduralStmtContinue *i);
    virtual void visitProceduralStmtDataDeclaration(IProceduralStmtDataDeclaration *i) override;
    void py_visitProceduralStmtDataDeclarationBase(IProceduralStmtDataDeclaration *i);
    virtual void visitProceduralStmtExpr(IProceduralStmtExpr *i) override;
    void py_visitProceduralStmtExprBase(IProceduralStmtExpr *i);
    virtual void visitProceduralStmtFunctionCall(IProceduralStmtFunctionCall *i) override;
    void py_visitProceduralStmtFunctionCallBase(IProceduralStmtFunctionCall *i);
    virtual void visitProceduralStmtIfElse(IProceduralStmtIfElse *i) override;
    void py_visitProceduralStmtIfElseBase(IProceduralStmtIfElse *i);
    virtual void visitActivityActionHandleTraversal(IActivityActionHandleTraversal *i) override;
    void py_visitActivityActionHandleTraversalBase(IActivityActionHandleTraversal *i);
    virtual void visitActivityActionTypeTraversal(IActivityActionTypeTraversal *i) override;
    void py_visitActivityActionTypeTraversalBase(IActivityActionTypeTraversal *i);
    virtual void visitProceduralStmtRepeatWhile(IProceduralStmtRepeatWhile *i) override;
    void py_visitProceduralStmtRepeatWhileBase(IProceduralStmtRepeatWhile *i);
    virtual void visitActivityForeach(IActivityForeach *i) override;
    void py_visitActivityForeachBase(IActivityForeach *i);
    virtual void visitActivityIfElse(IActivityIfElse *i) override;
    void py_visitActivityIfElseBase(IActivityIfElse *i);
    virtual void visitProceduralStmtWhile(IProceduralStmtWhile *i) override;
    void py_visitProceduralStmtWhileBase(IProceduralStmtWhile *i);
    virtual void visitActivityMatch(IActivityMatch *i) override;
    void py_visitActivityMatchBase(IActivityMatch *i);
    virtual void visitActivityRepeatCount(IActivityRepeatCount *i) override;
    void py_visitActivityRepeatCountBase(IActivityRepeatCount *i);
    virtual void visitActivityRepeatWhile(IActivityRepeatWhile *i) override;
    void py_visitActivityRepeatWhileBase(IActivityRepeatWhile *i);
    virtual void visitActivityReplicate(IActivityReplicate *i) override;
    void py_visitActivityReplicateBase(IActivityReplicate *i);
    virtual void visitActivitySelect(IActivitySelect *i) override;
    void py_visitActivitySelectBase(IActivitySelect *i);
    virtual void visitSymbolScope(ISymbolScope *i) override;
    void py_visitSymbolScopeBase(ISymbolScope *i);
    virtual void visitActivitySuper(IActivitySuper *i) override;
    void py_visitActivitySuperBase(IActivitySuper *i);
    virtual void visitConstraintBlock(IConstraintBlock *i) override;
    void py_visitConstraintBlockBase(IConstraintBlock *i);
    virtual void visitConstraintStmtForall(IConstraintStmtForall *i) override;
    void py_visitConstraintStmtForallBase(IConstraintStmtForall *i);
    virtual void visitConstraintStmtForeach(IConstraintStmtForeach *i) override;
    void py_visitConstraintStmtForeachBase(IConstraintStmtForeach *i);
    virtual void visitConstraintStmtImplication(IConstraintStmtImplication *i) override;
    void py_visitConstraintStmtImplicationBase(IConstraintStmtImplication *i);
    virtual void visitTypeScope(ITypeScope *i) override;
    void py_visitTypeScopeBase(ITypeScope *i);
    virtual void visitExprRefPathStaticFunc(IExprRefPathStaticFunc *i) override;
    void py_visitExprRefPathStaticFuncBase(IExprRefPathStaticFunc *i);
    virtual void visitExprRefPathSuper(IExprRefPathSuper *i) override;
    void py_visitExprRefPathSuperBase(IExprRefPathSuper *i);
    virtual void visitAction(IAction *i) override;
    void py_visitActionBase(IAction *i);
    virtual void visitActivityDecl(IActivityDecl *i) override;
    void py_visitActivityDeclBase(IActivityDecl *i);
    virtual void visitProceduralStmtSymbolBodyScope(IProceduralStmtSymbolBodyScope *i) override;
    void py_visitProceduralStmtSymbolBodyScopeBase(IProceduralStmtSymbolBodyScope *i);
    virtual void visitConstraintSymbolScope(IConstraintSymbolScope *i) override;
    void py_visitConstraintSymbolScopeBase(IConstraintSymbolScope *i);
    virtual void visitActivityLabeledScope(IActivityLabeledScope *i) override;
    void py_visitActivityLabeledScopeBase(IActivityLabeledScope *i);
    virtual void visitRootSymbolScope(IRootSymbolScope *i) override;
    void py_visitRootSymbolScopeBase(IRootSymbolScope *i);
    virtual void visitStruct(IStruct *i) override;
    void py_visitStructBase(IStruct *i);
    virtual void visitSymbolEnumScope(ISymbolEnumScope *i) override;
    void py_visitSymbolEnumScopeBase(ISymbolEnumScope *i);
    virtual void visitSymbolExtendScope(ISymbolExtendScope *i) override;
    void py_visitSymbolExtendScopeBase(ISymbolExtendScope *i);
    virtual void visitExecScope(IExecScope *i) override;
    void py_visitExecScopeBase(IExecScope *i);
    virtual void visitSymbolFunctionScope(ISymbolFunctionScope *i) override;
    void py_visitSymbolFunctionScopeBase(ISymbolFunctionScope *i);
    virtual void visitSymbolTypeScope(ISymbolTypeScope *i) override;
    void py_visitSymbolTypeScopeBase(ISymbolTypeScope *i);
    virtual void visitComponent(IComponent *i) override;
    void py_visitComponentBase(IComponent *i);
    virtual void visitProceduralStmtRepeat(IProceduralStmtRepeat *i) override;
    void py_visitProceduralStmtRepeatBase(IProceduralStmtRepeat *i);
    virtual void visitActivityParallel(IActivityParallel *i) override;
    void py_visitActivityParallelBase(IActivityParallel *i);
    virtual void visitActivitySchedule(IActivitySchedule *i) override;
    void py_visitActivityScheduleBase(IActivitySchedule *i);
    virtual void visitExecBlock(IExecBlock *i) override;
    void py_visitExecBlockBase(IExecBlock *i);
    virtual void visitActivitySequence(IActivitySequence *i) override;
    void py_visitActivitySequenceBase(IActivitySequence *i);
    virtual void visitProceduralStmtForeach(IProceduralStmtForeach *i) override;
    void py_visitProceduralStmtForeachBase(IProceduralStmtForeach *i);
};

} // namespace zsp
} // namespace ast

